Subject: Re: bug#51390: 29.0.50; repeat-mode: Fails to repeat keys in global-map(?)

From: Visuwesh <[email-masked]>
Date: Sun, 21 Nov 2021 03:21:58 +0100 (CET)

21 Nov 2021, 00:42 by [email-masked]:

Hi Juri,

>>>One problem I had with writing tests for such a feature — tests for repeat-mode
>>>are based on ‘execute-kbd-macro’, but an error ends the keyboard macro.
>>>So probably there will be no tests for this error-signaling repeatable commands.
>>
>> I wonder if the new mechanism added to ERT by Lars could be help here?
>> (and used by the indentation tests)  But I suppose you still have to end
>> up using keyboard macros one way or another...
>
> I don't know how buffer-based ERT fixtures could help to test repeatable
> key sequences. What I rather tried to do is to use ‘ert-simulate-command’
> (after removing ‘(cl-assert (not unread-command-events) t)’) and
> ‘ert-simulate-keys’ (after adding ‘(noninteractive nil)’ let-binding),
> to no avail.

I was thinking about grouping navigation commands that could `error'
(like in OP and the outline commands) in a repeatable keymap and making
use of Point-Char spec to test where the point ends up.
But I suppose this wouldn't get us anywhere since you still have to
"press" those keys somehow.